mod Ex06a

incl Mtex

incl Mtexrc

incl Maux

loc rem 
  \para \bf  6. CVIČENIE Z PREDMETU 1-INF-450 LOGIKA PRE INFORMATIKOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.20 
  \para* \it  Dátum:  \end streda 30.10.2013 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-625-lpp/1314zs/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Úvodná poznámka.  \end Toto cvičenie je venované primitívne 
  rekurzívnym funkciam (rekurzia so substitúciou v parametri, vnorená 
  jednoduchá rekurzia). Zadanie sa skladá z týchto súborov: 
  \items 
   \item \para Súbor(y) \it  mtex*.cl  \end obsahuje makrá pre CL-TeX. 
   \item \para Súbor(y) \it  maux*.cl  \end obsahuje definície niektorých 
         funkcií a predikátov. 
   \item \para Súbor(y) \it  ex*.cl  \end obsahuje úlohy, ktoré máte 
         riešiť na tomto cvičení. 
   \item \para Súbor \it  msyntax.cl  \end obsahuje syntax systému CL. 
  \end
  \para Tieto súbory sa musia skompilovať v správnom poradí. Presný postup 
  je uvedený v súbore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Počet bodov za úlohy v tomto súbore: 1 
   \item \para Počet bodov za prémiove úlohy v tomto súbore:: 0 
  \end
  \para Odovzdať do 3.11.2013 (pondelok) do 12:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara. Recursive Functions. Downloadable 
         lecture notes available through the web page of the course. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [3]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
   \item \para \it  [4]  \end I. Korec. Úvod do teórie algoritmov. Skriptá 
         MFF UK, 1981. 
  \end

rem 
  \para \bf  [CL] CL-TeX.  \end 

appldisp/2 Tex_f2_s
  Std('s',0)

appldisp/2 Tex_f2_rec_rsb_x
  Prefix(90,2,Subsup(Id(2,'x',0),75,Arg(0),None),Arg(1))

appldisp/3 Tex_f3_rec_rsb_y
  Prefix(90,2,Subsup(Id(2,'y',0),75,Arg(0),None),
         Fenced(Op('(',0),Infix(Arg(1),30,2,Op(',',0),Arg(2)),Op(')',0)))

appldisp/3 Tex_f3_rec_rsb_cvsf_f
  Infix(Prefix(90,2,Underover(Id(1,'f',0),None,Op(Ent('OverBar'),0)),
               Fenced(Op('(',0),Infix(Arg(1),30,2,Op(',',0),Arg(2)),Op(')',0))),59,1,
        Id(2,'.',0),Arg(0))

rem 
  \para \bf  Chapter. Primitive Recursive Functions.  \end 

rem 
  \para \bf  Section. Recursion with Parameter Substitution.  \end 

rem 
  \para \bf  Subsection. Recursion with Parameter Substitution: Case 
  \ft k = 1 \end and One Parameter.  \end 

theory Recursion_with_parameter_substitution

fun G 'Tex_f1_g'

fun/3 H1 'Tex_f3_h'

fun/2 Sb 'Tex_f2_s'

loc rem 
  \para \bf  Exercise. \it  (1 point)  \end  \end 
  \header* fun/2 F 'Tex_f2_f' \end Show that if \ft G(y) \end, 
  \ft H1(x,z,y) \end and \ft Sb(x,y) \end are all primitive recursive then so is 
  \ft F(x,y) \end defined by 

fun/2 F 'Tex_f2_f'
  F(0,y) = G(y)
  F(x+1,y) = H1(x,F(x,Sb(x,y)),y)

loc rem 
  \para \it  Hint.  \end \header* fun/2 Cvf 'Tex_f2_rec_cvf_f' \end Derive 
  \ft F(x,y) \end as a p.r. function with the help of its course of values 
  function \ft Cvf(x,y) \end: 

fun/2 Cvf 'Tex_f2_rec_cvf_f'
  Cvf(0,y) = F(0,y),0
  Cvf(x+1,y) = F(x+1,y),Cvf(x,Sb(x,y))

loc rem 
  \para \it  Proof.  \end 

loc rem 
  \para \it  Selector for recursive arguments.  \end 
  \header* fun/2 X 'Tex_f2_rec_rsb_x' \end Show that the selector function 
  \ft X(i,x) \end is primitive recursive. 

fun/2 X 'Tex_f2_rec_rsb_x'
  X(i,x) = Foo

loc rem 
  \para \it  Selector for parameters.  \end 
  \header* fun/3 Y 'Tex_f3_rec_rsb_y' \end Show that the selector function 
  \ft Y(i,x,y) \end is primitive recursive. 

fun/3 Y 'Tex_f3_rec_rsb_y'
  Y(i,x,y) = Foo

loc rem 
  \para \it  Partial course of values sequence.  \end 
  \header* fun/3 Cvsf 'Tex_f3_rec_rsb_cvsf_f' \end Show that the auxiliary 
  ternary function \ft Cvsf(i,x,y) \end such that 
  \eq* 
    i <= x -> Cvsf(i,x,y) = Cvf(X(i,x),Y(i,x,y))
  \end
  \para is primitive recursive. 

fun/3 Cvsf 'Tex_f3_rec_rsb_cvsf_f'
  Cvsf(i,x,y) = Foo

loc rem 
  \para \it  Course of values function.  \end 
  \header* fun/2 Cvf 'Tex_f2_rec_cvf_f' \end Show that the function 
  \ft Cvf(x,y) \end is primitive recursive. 

fun/2 Cvf_is_primrec 'Tex_f2_rec_cvf_f'
  Cvf_is_primrec(x,y) = Foo

loc rem 
  \para \it  Final step.  \end Show that the function \ft F(x,y) \end is 
  primitive recursive. 

fun/2 F_is_primrec 'Tex_f2_f'
  F_is_primrec(x,y) = Foo

end theory Recursion_with_parameter_substitution

rem 
  \para \bf  [CL] Remark.  \end You can test your solution by \it  interpreting 
   \end the theory. Choose \it  non-local  \end interpretation. 

rem 
  \para \bf  Subsection. Recursion with Parameter Substitution: General Case. 
   \end 

rem 
  \para \bf  Theorem.  \end Primitive recursive functions are closed under 
  recursion with parameter substitution. 

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc rem 
  Interpretation of theory Recursion_with_parameter_substitution
  G(x1) = x1+1
  H1(x1,x2,x3) = x1+x2+x3
  Sb(x1,x2) = x1+x2

loc rem 
  Some useful queries
  0,0 = x,y & F(x,y) = z
  0,0 = x,y & Cvf(x,y) = s
  0,0 = x,y & Cvf_is_primrec(x,y) = s
  0,0 = x,y & F_is_primrec(x,y) = z
  data,0,0 = i,x,y & Cvf(x,y) = s1 & Cvsf(x-i,x,y) = s2 & data+1 = data99

